clear all

%======================================
% Driver for the element diffusion matrix
%======================================

x1 = 0.00; y1 = 0.00;
x2 = 1.20; y2 = 0.89;
x3 = 0.11; y3 = 1.31;

x4 = 0.5*(x1+x2); y4=0.5*(y1+y2);
x5 = 0.5*(x2+x3); y5=0.5*(y2+y3);
x6 = 0.5*(x3+x1); y6=0.5*(y3+y1);

NQ=7;

[edm, arel] = edm6 ...
...
   (x1,y1, x2,y2, x3,y3, x4,y4, x5,y5, x6,y6, NQ);

PHI = [ y3-y1 -y2+y1;
       -x3+x1  x2-x1];

QQQ = PHI'*PHI;
O = [ (x3-x1)*(x3-x1)+(y3-y1)*(y3-y1), (x3-x1)*(x2-x1)+(y3-y1)*(y2-y1) ;
      (x3-x1)*(x2-x1)+(y3-y1)*(y2-y1), (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1) ];

edm

%---
% analytically
%---

edma = zeros(6,6);

edma(1,1) = 1.0/(2.0*arel) * 0.5*(QQQ(1,1)+QQQ(1,2)+QQQ(2,1)+QQQ(2,2));
edma(2,2) = 1.0/(2.0*arel) * 0.5*QQQ(1,1);
edma(3,3) = 1.0/(2.0*arel) * 0.5*QQQ(2,2);
edma(4,4) = 1.0/(2.0*arel) * 2.0/3.0*(2.0*QQQ(1,1)+QQQ(1,2)+QQQ(2,1)+2.0*QQQ(2,2));
edma(5,5) = 1.0/(2.0*arel) * 2.0/3.0*(2.0*QQQ(1,1)+QQQ(1,2)+QQQ(2,1)+2.0*QQQ(2,2));
edma(6,6) = 1.0/(2.0*arel) * 2.0/3.0*(2.0*QQQ(1,1)+QQQ(1,2)+QQQ(2,1)+2.0*QQQ(2,2));

edma(1,2) = 1.0/(2.0*arel) * 1/6*(QQQ(1,1)+QQQ(1,2));
edma(1,3) = 1.0/(2.0*arel) * 1/6*(QQQ(2,1)+QQQ(2,2));
edma(1,4) =-1.0/(2.0*arel) * 2/3*(QQQ(1,1)+QQQ(2,1));
edma(1,5) = 0.0;
edma(1,6) =-1.0/(2.0*arel) * 2/3*(QQQ(1,2)+QQQ(2,2));
edma(2,3) =-1.0/(2.0*arel) * 1/6*(QQQ(1,2));
edma(2,5) = 1.0/(2.0*arel) * 2/3*(QQQ(1,2));
edma(4,5) =-1.0/(2.0*arel) * 2/3*(QQQ(1,2)+QQQ(2,1)+2*QQQ(2,2));
edma(4,6) = 1.0/(2.0*arel) * 2/3*(QQQ(1,2)+QQQ(2,1));
edma(5,6) =-1.0/(2.0*arel) * 2.0/3.0*(2.0*QQQ(1,1)+QQQ(1,2)+QQQ(2,1));

edma(2,4) = edm(1,4);
edma(3,5) = edm(2,5);
edma(3,6) = edm(1,6);

edma
