function [Dinv] = herm10_Dinv (x1,y1, x2,y2, x3,y3, x4,y4)

%=======================================
% Compute the inverse of the matrix D
% for a 4-node, 10-mode Hermite triangle
%=======================================

%------------------------------
% define the coefficient matrix
%------------------------------

D = [ ...
...
1  x1  y1  x1^2  x1*y1  y1^2  x1^3  x1^2*y1  x1*y1^2  y1^3   ; ...
0  1   0   2*x1   y1     0  3*x1^2  2*x1*y1   y1^2       0   ; ...
0  0   1    0     x1   2*y1   0       x1^2   2*x1*y1  3*y1^2 ; ...
1  x2  y2  x2^2  x2*y2  y2^2  x2^3  x2^2*y2  x2*y2^2  y2^3   ; ...
0  1   0   2*x2   y2     0  3*x2^2  2*x2*y2   y2^2       0   ; ...
0  0   1    0     x2   2*y2   0       x2^2   2*x2*y2  3*y2^2 ; ...
1  x3  y3  x3^2  x3*y3  y3^2  x3^3  x3^2*y3  x3*y3^2  y3^3   ; ...
0  1   0   2*x3   y3     0  3*x3^2  2*x3*y3   y3^2       0   ; ...
0  0   1    0     x3   2*y3   0       x3^2   2*x3*y3  3*y3^2 ; ...
1  x4  y4  x4^2  x4*y4  y4^2  x4^3  x4^2*y4  x4*y4^2  y4^3   ; ...
];

%--------------------
% compute the inverse
%--------------------

Dinv = inv(D);

%-----
% done
%-----

return
