 function [x1,y1,z1, x2,y2,z2, x3,y3,z3, x4,y4,z4 ...
          ,x5,y5,z5, x6,y6,z6, x7,y7,z7, x8,y8,z8 ...
          ,x9,y9,z9, x10,y10,z10, x11,y11,z11, x12,y12,z12] ...
          ...
          = tetra4_sub12 (x,y,z)

%========================
% tetra4_sub12
%
% subdivide a tetrahedron
% into 12 sub-elements
%========================

% edge mid-nodes

xe12=0.5*(x(1)+x(2)); ye12=0.5*(y(1)+y(2)); ze12=0.5*(z(1)+z(2));
xe13=0.5*(x(1)+x(3)); ye13=0.5*(y(1)+y(3)); ze13=0.5*(z(1)+z(3));
xe14=0.5*(x(1)+x(4)); ye14=0.5*(y(1)+y(4)); ze14=0.5*(z(1)+z(4));
xe23=0.5*(x(2)+x(3)); ye23=0.5*(y(2)+y(3)); ze23=0.5*(z(2)+z(3));
xe24=0.5*(x(2)+x(4)); ye24=0.5*(y(2)+y(4)); ze24=0.5*(z(2)+z(4));
xe34=0.5*(x(3)+x(4)); ye34=0.5*(y(3)+y(4)); ze34=0.5*(z(3)+z(4));

% centroid

xc = 0.25*(x(1)+x(2)+x(3)+x(4));
yc = 0.25*(y(1)+y(2)+y(3)+y(4));
zc = 0.25*(z(1)+z(2)+z(3)+z(4));

%------------------
% first tetrahedron
%------------------

x1(1)=xe13; y1(1)=ye13; z1(1)=ze13;
x1(2)=xe23; y1(2)=ye23; z1(2)=ze23;
x1(3)=x(3); y1(3)=y(3); z1(3)=z(3);
x1(4)=xe34; y1(4)=ye34; z1(4)=ze34;

%------------------
% second tetrahedron
%------------------

x2(1)=xe12; y2(1)=ye12; z2(1)=ze12;
x2(2)=x(2); y2(2)=y(2); z2(2)=z(2);
x2(3)=xe23; y2(3)=ye23; z2(3)=ze23;
x2(4)=xe24; y2(4)=ye24; z2(4)=ze24;

%------------------
% third tetrahedron
%------------------

x3(1)=xe14; y3(1)=ye14; z3(1)=ze14;
x3(2)=xe24; y3(2)=ye24; z3(2)=ze24;
x3(3)=xe34; y3(3)=ye34; z3(3)=ze34;
x3(4)=x(4); y3(4)=y(4); z3(4)=z(4);

%-------------------
% fourth tetrahedron
%-------------------

x4(1)=x(1); y4(1)=y(1); z4(1)=z(1);
x4(2)=xe12; y4(2)=ye12; z4(2)=ze12;
x4(3)=xe13; y4(3)=ye13; z4(3)=ze13;
x4(4)=xe14; y4(4)=ye14; z4(4)=ze14;

%-------------------
% fifth tetrahedron
%-------------------

x5(1)=xe13; y5(1)=ye13; z5(1)=ze13;
x5(2)=xe23; y5(2)=ye23; z5(2)=ze23;
x5(3)=xe34; y5(3)=ye34; z5(3)=ze34;
x5(4)=xc;   y5(4)=yc;   z5(4)=zc;

%------------------
% sixth tetrahedron
%------------------

x6(1)=xe12; y6(1)=ye12; z6(1)=ze12;
x6(2)=xe24; y6(2)=ye24; z6(2)=ze24;
x6(3)=xe23; y6(3)=ye23; z6(3)=ze23;
x6(4)=xc;   y6(4)=yc;   z6(4)=zc;

%--------------------
% seventh tetrahedron
%--------------------

x7(1)=xe14; y7(1)=ye14; z7(1)=ze14;
x7(2)=xe34; y7(2)=ye34; z7(2)=ze34;
x7(3)=xe24; y7(3)=ye24; z7(3)=ze24;
x7(4)=xc;   y7(4)=yc;   z7(4)=zc;

%-------------------
% eighth tetrahedron
%-------------------

x8(1)=xe14; y8(1)=ye14; z8(1)=ze14;
x8(2)=xe12; y8(2)=ye12; z8(2)=ze12;
x8(3)=xe13; y8(3)=ye13; z8(3)=ze13;
x8(4)=xc;   y8(4)=yc;   z8(4)=zc;

%-------------------
% ninth tetrahedron
%-------------------

x9(1)=xe24; y9(1)=ye24; z9(1)=ze24;
x9(2)=xe34; y9(2)=ye34; z9(2)=ze34;
x9(3)=xe23; y9(3)=ye23; z9(3)=ze23;
x9(4)=xc;   y9(4)=yc;   z9(4)=zc;

%-------------------
% tenth tetrahedron
%-------------------

x10(1)=xe14; y10(1)=ye14; z10(1)=ze14;
x10(2)=xe13; y10(2)=ye13; z10(2)=ze13;
x10(3)=xe34; y10(3)=ye34; z10(3)=ze34;
x10(4)=xc;   y10(4)=yc;   z10(4)=zc;

%-------------------
% eleventh tetrahedron
%-------------------

x11(1)=xe14; y11(1)=ye14; z11(1)=ze14;
x11(2)=xe24; y11(2)=ye24; z11(2)=ze24;
x11(3)=xe12; y11(3)=ye12; z11(3)=ze12;
x11(4)=xc;   y11(4)=yc;   z11(4)=zc;

%-------------------
% twelfth tetrahedron
%-------------------

x12(1)=xe12; y12(1)=ye12; z12(1)=ze12;
x12(2)=xe23; y12(2)=ye23; z12(2)=ze23;
x12(3)=xe13; y12(3)=ye13; z12(3)=ze13;
x12(4)=xc;   y12(4)=yc;   z12(4)=zc;

%-----
% done
%-----

return
