 function [x1,y1,z1, x2,y2,z2, x3,y3,z3, x4,y4,z4 ...
          ,x5,y5,z5, x6,y6,z6, x7,y7,z7, x8,y8,z8 ]...
          ...
          = tetra4_sub8 (x,y,z)

%========================
% tetra4_sub8
%
% subdivide a 4-node tetrahedron
% into 8 sub-elements
%========================

% mid-edge nodes

xe12=0.5*(x(1)+x(2)); ye12=0.5*(y(1)+y(2)); ze12=0.5*(z(1)+z(2));
xe13=0.5*(x(1)+x(3)); ye13=0.5*(y(1)+y(3)); ze13=0.5*(z(1)+z(3));
xe14=0.5*(x(1)+x(4)); ye14=0.5*(y(1)+y(4)); ze14=0.5*(z(1)+z(4));
xe23=0.5*(x(2)+x(3)); ye23=0.5*(y(2)+y(3)); ze23=0.5*(z(2)+z(3));
xe24=0.5*(x(2)+x(4)); ye24=0.5*(y(2)+y(4)); ze24=0.5*(z(2)+z(4));
xe34=0.5*(x(3)+x(4)); ye34=0.5*(y(3)+y(4)); ze34=0.5*(z(3)+z(4));

%------------------
% first tetrahedron
%------------------

x1(1)=xe13; y1(1)=ye13; z1(1)=ze13;
x1(2)=xe23; y1(2)=ye23; z1(2)=ze23;
x1(3)=x(3); y1(3)=y(3); z1(3)=z(3);
x1(4)=xe34; y1(4)=ye34; z1(4)=ze34;

%------------------
% second tetrahedron
%------------------

x2(1)=xe12; y2(1)=ye12; z2(1)=ze12;
x2(2)=x(2); y2(2)=y(2); z2(2)=z(2);
x2(3)=xe23; y2(3)=ye23; z2(3)=ze23;
x2(4)=xe24; y2(4)=ye24; z2(4)=ze24;

%------------------
% third tetrahedron
%------------------

x3(1)=xe14; y3(1)=ye14; z3(1)=ze14;
x3(2)=xe24; y3(2)=ye24; z3(2)=ze24;
x3(3)=xe34; y3(3)=ye34; z3(3)=ze34;
x3(4)=x(4); y3(4)=y(4); z3(4)=z(4);

%-------------------
% fourth tetrahedron
%-------------------

x4(1)=x(1); y4(1)=y(1); z4(1)=z(1);
x4(2)=xe12; y4(2)=ye12; z4(2)=ze12;
x4(3)=xe13; y4(3)=ye13; z4(3)=ze13;
x4(4)=xe14; y4(4)=ye14; z4(4)=ze14;

%-------------------
% fifth tetrahedron
%-------------------

x5(1)=xe34; y5(1)=ye34; z5(1)=ze34;
x5(2)=xe24; y5(2)=ye24; z5(2)=ze24;
x5(3)=xe14; y5(3)=ye14; z5(3)=ze14;
x5(4)=xe13; y5(4)=ye13; z5(4)=ze13;

%------------------
% sixth tetrahedron
%------------------

x6(1)=xe14; y6(1)=ye14; z6(1)=ze14;
x6(2)=xe12; y6(2)=ye12; z6(2)=ze12;
x6(3)=xe13; y6(3)=ye13; z6(3)=ze13;
x6(4)=xe24; y6(4)=ye24; z6(4)=ze24;

%--------------------
% seventh tetrahedron
%--------------------

x7(1)=xe12; y7(1)=ye12; z7(1)=ze12;
x7(2)=xe23; y7(2)=ye23; z7(2)=ze23;
x7(3)=xe13; y7(3)=ye13; z7(3)=ze13;
x7(4)=xe24; y7(4)=ye24; z7(4)=ze24;

%-------------------
% eighth tetrahedron
%-------------------

x8(1)=xe13; y8(1)=ye13; z8(1)=ze13;
x8(2)=xe24; y8(2)=ye24; z8(2)=ze24;
x8(3)=xe23; y8(3)=ye23; z8(3)=ze23;
x8(4)=xe34; y8(4)=ye34; z8(4)=ze34;

%-----
% done
%-----

return
